--  TotemGuru is a world of warcraft addon for showing totems during raiding
--  Copyright (C) 2009 Jon Edmunds (je95(AT)zepler.org.uk)
--  Create Date : 8/16/2009 9:16:05 AM
--  This file is part of the TotemGuru Wow Addon.
--
--  TotemGuru is free software: you can redistribute it and/or modify
--  it under the terms of the GNU General Public License as published by
--  the Free Software Foundation, either version 3 of the License, or
--  (at your option) any later version.
-- 
--  TotemGuru is distributed in the hope that it will be useful,
--  but WITHOUT ANY WARRANTY; without even the implied warranty of
--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--  GNU General Public License for more details.
-- 
--  You should have received a copy of the GNU General Public License
--  along with TotemGuru.  If not, see <http://www.gnu.org/licenses/>.

--some local variables
TotemGuru_air_school=4
TotemGuru_water_school=3
TotemGuru_earth_school=2
TotemGuru_fire_school=1


-- These textuers were found by printing the icon field from the combat log message for 'SPELL_SUMMON'
-- if these stop working then add a print(icon) line into the event handler and drop the totem you
-- want to monitor to see the image path, and then add it in here.
-- you can also fool this by using other icons for other abilities if you wnt to see them appear in the list
TotemGuru_Textures = 
	{
		Grounding = "Interface\\Icons\\Spell_Nature_GroundingTotem",
	  Windfury = "Interface\\Icons\\Spell_Nature_Windfury",
	  WrathOfAir = "Interface\\Icons\\Spell_Nature_SlowingTotem",
		ManaSpring = "Interface\\Icons\\Spell_Nature_ManaRegenTotem",
		HealingStream = "Interface\\Icons\\INV_Spear_04",
		ManaTide = "Interface\\Icons\\Spell_Frost_SummonWaterElemental",
	  StoneClaw = "Interface\\Icons\\Spell_Nature_StoneClawTotem",
	  EarthBind = "Interface\\Icons\\Spell_Nature_StrengthOfEarthTotem02",
	  StoneSkin = "Interface\\Icons\\Spell_Nature_StoneSkinTotem",
	  StrengthOfEarth = "Interface\\Icons\\Spell_Nature_EarthBindTotem",
		EarthElemental = "Interface\\Icons\\Spell_Nature_EarthElemental_Totem",
		Tremor = "Interface\\Icons\\Spell_Nature_TremorTotem",
		Searing = "Interface\\Icons\\Spell_Fire_SearingTotem",
		Magma = "Interface\\Icons\\Spell_Fire_SelfDestruct",
		FlameTongue = "Interface\\Icons\\Spell_Nature_GuardianWard",
		FireElemental = "Interface\\Icons\\Spell_Fire_Elemental_Totem",
		TranquilMind = "Interface\\Icons\\Spell_Nature_Brilliance",
		ElementalResistance = "Interface\\Icons\\Spell_FireResistanceTotem_01",
	}
	
-- less processing to do it this way that searching and its only a small table :P
TotemGuru_Totem_Message_Ids = 
	{
		[1] = TotemGuru_Textures.Grounding,
		[TotemGuru_Textures.Grounding] = 1,
		[2] = TotemGuru_Textures.Windfury,
		[TotemGuru_Textures.Windfury] = 2,
		[3] = TotemGuru_Textures.ManaSpring,
		[TotemGuru_Textures.ManaSpring] = 3,
		[4] = TotemGuru_Textures.WrathOfAir,
		[TotemGuru_Textures.WrathOfAir] = 4,
		[5] = TotemGuru_Textures.TranquilMind,
		[TotemGuru_Textures.TranquilMind] = 5,
		[6] = TotemGuru_Textures.ElementalResistance,
		[TotemGuru_Textures.ElementalResistance] = 6,
		[7] = TotemGuru_Textures.HealingStream,
		[TotemGuru_Textures.HealingStream] = 7,
		[8] = TotemGuru_Textures.ManaTide,
	    	[TotemGuru_Textures.ManaTide] = 8,
		[9] = TotemGuru_Textures.StoneClaw,
		[TotemGuru_Textures.StoneClaw] = 9,
		[10] = TotemGuru_Textures.EarthBind,
		[TotemGuru_Textures.EarthBind] = 10,
		[11] = TotemGuru_Textures.StoneSkin,
		[TotemGuru_Textures.StoneSkin] = 11,
		[12] = TotemGuru_Textures.StrengthOfEarth,
		[TotemGuru_Textures.StrengthOfEarth] = 12,
		[13] = TotemGuru_Textures.EarthElemental,
		[TotemGuru_Textures.EarthElemental] = 13,
		[14] = TotemGuru_Textures.Tremor,
		[TotemGuru_Textures.Tremor] = 14,
		[15] = TotemGuru_Textures.Searing,
		[TotemGuru_Textures.Searing] = 15,
		[16] = TotemGuru_Textures.Magma,
		[TotemGuru_Textures.Magma] = 16,
		[17] = TotemGuru_Textures.FlameTongue,
		[TotemGuru_Textures.FlameTongue] = 17,
		[18] = TotemGuru_Textures.FireElemental,
		[TotemGuru_Textures.FireElemental] = 18,
		
	}

-- The main data array for totems. Ranks are spellId and an '*' on the
-- name is to indicate that its not the highest rank available
TotemGuruTotemsInfo = 
	{
		[TotemGuru_Textures.Grounding] = 
		{
			school = TotemGuru_air_school,
			name = "Grounding Totem",
			effect = "Absorbs one harmful spell cast on a nearby party member to iteself",
			range = "0",
			duration = 45, 
			spellID = 8177
		},
		[TotemGuru_Textures.Windfury] = 
		{
			school = TotemGuru_air_school,
			name = "Windfury Totem",
			effect = "Provides melee haste to all party members",
			range = "30",
			duration = 300,
			spellID = 8512
	            
		},
		[TotemGuru_Textures.ManaSpring] = 
		{
			school = TotemGuru_water_school,
			name = "Mana Spring Totem",
			effect = "Restores mana every 2 seconds to group members",
			range = "30",
			duration = 300,
			spellID = 5675
		},
		[TotemGuru_Textures.WrathOfAir] = 
		{
			school = TotemGuru_air_school,
			name = "Wrath of Air Totem",
			effect = "Provides spell haste to all party members",
			range = "30",
			duration = 300,
			spellID = 3738
		},
		[TotemGuru_Textures.TranquilMind] = 
		{
			school = TotemGuru_water_school,
			name = "Totem of Tranquil Mind",
			effect = "Summons a Totem of Tranquil Mind with 5 health at the feet of the caster for 5 min, causing party or raid members within 30 yards to lose 30% less casting or channeling time when damaged.",
			range = "30",
			duration = 300,
			spellID = 87718
		},	
		[TotemGuru_Textures.ElementalResistance] = 
		{
			school = TotemGuru_water_school,
			name = "Elemental Resistance Totem",
			effect = "Summons an Elemental Resistance Totem with 5 health at the feet of the caster for 5 min that increases the Fire, Frost, and Nature resistance of party and raid members within 30.",
			range = "30",
			duration = 300,
			spellID = 8184
		},	
		[TotemGuru_Textures.HealingStream] = 
		{
			school = TotemGuru_water_school,
			name = "Healing Stream Totem",
			effect = "Heals group members every 2 seconds",
			range = "20",
			duration = 300,
			spellID = 5394
		},
		[TotemGuru_Textures.ManaTide] = 
		{
			school = TotemGuru_water_school,
			name = "Mana Tide Totem",
			effect = "Gain 6% of total mana every 3 seconds.",
			range = "0",
			duration = 12,
			spellID = 16191
   		},
		[TotemGuru_Textures.StoneClaw] = 
		{
			school = TotemGuru_earth_school,
			name = "Stoneclaw Totem",
			effect = "Has 1620 health and taunts creatures. 50% chance to stun for 3 sec. Protects all casters totems",
			range = "8",
			duration = 15,
			spellID = 5730
		},
		[TotemGuru_Textures.EarthBind] = 
		{
			school = TotemGuru_earth_school,
			name = "Earthbind Totem",
			effect = "Slows enemy movement",
			range = "10",
			duration = 45,
  			spellID = 8177
  		},
		[TotemGuru_Textures.StoneSkin] = 
		{
			school = TotemGuru_earth_school,
			name = "Stoneskin Totem",
			effect = "Increasing party members armor by 1150.  Lasts 5 min.",
			range = "30",
			duration = 300,
			spellID = 8071
		},
		[TotemGuru_Textures.StrengthOfEarth] = 
		{
			school = TotemGuru_earth_school,
			name = "Strength Of Earth Totem",
			effect = "Increases the strength and agility of all party members",
			range = "30",
			duration = 300,
			spellID = 8075
		},
		[TotemGuru_Textures.EarthElemental] = 
		{
			school = TotemGuru_earth_school,
			name = "Earth Elemental Totem",
			effect = "Calls forth a greater earth elemental to protect the caster and <his/her> allies.",
			range = "0",
			duration = 120,
			spellID = 2062
		},
		[TotemGuru_Textures.Tremor] = 
		{
			school = TotemGuru_earth_school,
			name = "Tremor Totem",
			effect = "Shakes the ground around it, removing Fear, Charm and Sleep effects from party members",
			range = "30",
			duration = 300,
			spellID = 8143
		},
		[TotemGuru_Textures.Searing] = 
		{
			school = TotemGuru_fire_school,
			name = "Searing Totem",
			effect = "Repeatedly attacks an enemy with Fire damage",
			range = "20",
			duration = 60,
			spellID = 3599
		},
		[TotemGuru_Textures.Magma] = 
		{
			school = TotemGuru_fire_school,
			name = "Magma Totem",
			effect = "Fire damage to all creatures within 8 yards every 2 seconds",
			range = "",
			duration = 20,
			spellID = 8190
		},
		[TotemGuru_Textures.FlameTongue] = 
		{
			school = TotemGuru_fire_school,
			name = "Flametongue Totem",
			effect = "Increases spell and healing of party memebers",
			range = "30",
			duration = 300,
			spellID = 8227
		},	
		[TotemGuru_Textures.FireElemental] = 
		{
			school = TotemGuru_fire_school,
			name = "Fire Elemental Totem",
			effect = "Calls forth a greater fire elemental to rain destruction on the caster's enemies.",
			range = "",
			duration = 120,
			spellID = 2894
		},
	
}
